# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['GroupMembershipsArgs', 'GroupMemberships']

@pulumi.input_type
class GroupMembershipsArgs:
    def __init__(__self__, *,
                 group_id: pulumi.Input[str],
                 users: pulumi.Input[Sequence[pulumi.Input[str]]],
                 track_all_users: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a GroupMemberships resource.
        :param pulumi.Input[str] group_id: ID of a Okta group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] users: The list of Okta user IDs which the group should have membership managed for.
        :param pulumi.Input[bool] track_all_users: The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        """
        GroupMembershipsArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            group_id=group_id,
            users=users,
            track_all_users=track_all_users,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             group_id: Optional[pulumi.Input[str]] = None,
             users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             track_all_users: Optional[pulumi.Input[bool]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if group_id is None and 'groupId' in kwargs:
            group_id = kwargs['groupId']
        if group_id is None:
            raise TypeError("Missing 'group_id' argument")
        if users is None:
            raise TypeError("Missing 'users' argument")
        if track_all_users is None and 'trackAllUsers' in kwargs:
            track_all_users = kwargs['trackAllUsers']

        _setter("group_id", group_id)
        _setter("users", users)
        if track_all_users is not None:
            _setter("track_all_users", track_all_users)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Input[str]:
        """
        ID of a Okta group.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter
    def users(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The list of Okta user IDs which the group should have membership managed for.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter(name="trackAllUsers")
    def track_all_users(self) -> Optional[pulumi.Input[bool]]:
        """
        The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        """
        return pulumi.get(self, "track_all_users")

    @track_all_users.setter
    def track_all_users(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "track_all_users", value)


@pulumi.input_type
class _GroupMembershipsState:
    def __init__(__self__, *,
                 group_id: Optional[pulumi.Input[str]] = None,
                 track_all_users: Optional[pulumi.Input[bool]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering GroupMemberships resources.
        :param pulumi.Input[str] group_id: ID of a Okta group.
        :param pulumi.Input[bool] track_all_users: The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] users: The list of Okta user IDs which the group should have membership managed for.
        """
        _GroupMembershipsState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            group_id=group_id,
            track_all_users=track_all_users,
            users=users,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             group_id: Optional[pulumi.Input[str]] = None,
             track_all_users: Optional[pulumi.Input[bool]] = None,
             users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if group_id is None and 'groupId' in kwargs:
            group_id = kwargs['groupId']
        if track_all_users is None and 'trackAllUsers' in kwargs:
            track_all_users = kwargs['trackAllUsers']

        if group_id is not None:
            _setter("group_id", group_id)
        if track_all_users is not None:
            _setter("track_all_users", track_all_users)
        if users is not None:
            _setter("users", users)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of a Okta group.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter(name="trackAllUsers")
    def track_all_users(self) -> Optional[pulumi.Input[bool]]:
        """
        The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        """
        return pulumi.get(self, "track_all_users")

    @track_all_users.setter
    def track_all_users(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "track_all_users", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of Okta user IDs which the group should have membership managed for.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "users", value)


class GroupMemberships(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 track_all_users: Optional[pulumi.Input[bool]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Resource to manage a set of group memberships for a specific group.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_id: ID of a Okta group.
        :param pulumi.Input[bool] track_all_users: The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] users: The list of Okta user IDs which the group should have membership managed for.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GroupMembershipsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource to manage a set of group memberships for a specific group.

        :param str resource_name: The name of the resource.
        :param GroupMembershipsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GroupMembershipsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            GroupMembershipsArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 track_all_users: Optional[pulumi.Input[bool]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GroupMembershipsArgs.__new__(GroupMembershipsArgs)

            if group_id is None and not opts.urn:
                raise TypeError("Missing required property 'group_id'")
            __props__.__dict__["group_id"] = group_id
            __props__.__dict__["track_all_users"] = track_all_users
            if users is None and not opts.urn:
                raise TypeError("Missing required property 'users'")
            __props__.__dict__["users"] = users
        super(GroupMemberships, __self__).__init__(
            'okta:index/groupMemberships:GroupMemberships',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            group_id: Optional[pulumi.Input[str]] = None,
            track_all_users: Optional[pulumi.Input[bool]] = None,
            users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'GroupMemberships':
        """
        Get an existing GroupMemberships resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_id: ID of a Okta group.
        :param pulumi.Input[bool] track_all_users: The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] users: The list of Okta user IDs which the group should have membership managed for.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GroupMembershipsState.__new__(_GroupMembershipsState)

        __props__.__dict__["group_id"] = group_id
        __props__.__dict__["track_all_users"] = track_all_users
        __props__.__dict__["users"] = users
        return GroupMemberships(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Output[str]:
        """
        ID of a Okta group.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="trackAllUsers")
    def track_all_users(self) -> pulumi.Output[Optional[bool]]:
        """
        The resource concerns itself with all users added/deleted to the group; even those managed outside of the resource.
        """
        return pulumi.get(self, "track_all_users")

    @property
    @pulumi.getter
    def users(self) -> pulumi.Output[Sequence[str]]:
        """
        The list of Okta user IDs which the group should have membership managed for.
        """
        return pulumi.get(self, "users")

